#include <amxmodx>
#include <amxmisc>
#include <hamsandwich>

#define PLUGIN "prize_xp"
#define VERSION "2.1"
#define AUTHOR "prize_xp"

new g_mostheadshots[33], cvar_logs
new CurrentTime[9]   

enum Color {
	NORMAL = 1,	// clients scr_concolor cvar color
	GREEN,		// Green
	TEAM_COLOR,	// Red, grey, blue
	GREY,		// grey
	RED,		// Red
	BLUE,		// Blue
};

new TeamName[][] = {
	"",
	"TERRORIST",
	"CT",
	"SPECTATOR"
};

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_event("DeathMsg","Event_DeathMsg","a","3=1")
	register_event("30","event_intermission","a")
	cvar_logs = register_cvar("amx_headshots_logs", "0")
	register_cvar("Best Player Headshot", AUTHOR, FCVAR_SERVER|FCVAR_PROTECTED)
	register_clcmd("","giveexp")
}
public client_disconnect( id ) g_mostheadshots[ id ] = 0
public event_intermission( ) set_task( 0.1, "BestHeadPlayer")


public giveexp() 
{ 
	get_time ("20H:40M:10S",CurrentTime,8) 
	server_cmd( "wc3_givexp @ALL 10000", CurrentTime ); 
	client_print(0,3,"Текущее Время: %s",CurrentTime) 
}




public BestHeadPlayer( )
{	
	new iPlayers[32], iNum
	get_players( iPlayers, iNum )
		    
	if(!iNum)
	{
		return;
	}
	
	new iBestPlayerHeadshot = iPlayers[ 0 ]
		    
	for(new i = 1, id; i < iNum; i++) 
	{ 
		id = iPlayers[ i ] 
			
		if(g_mostheadshots[ id ] > g_mostheadshots[ iBestPlayerHeadshot ]) 
		{ 
			iBestPlayerHeadshot = id 
		} 
	}
	
	static szName[32] 
	get_user_name(iBestPlayerHeadshot,szName,charsmax(szName)) 
	
	ColorChat(0, BLUE, "^x04[AMXX]^x01Победитель карты ^x03%s ^x01сделал ^x03%d ^x01хедшотов",szName, g_mostheadshots[iBestPlayerHeadshot], g_mostheadshots[ iBestPlayerHeadshot ] > 1 ? "s." : ".")
	ColorChat(0, RED, "^x04[AMXX]^x01Его ^x03награда ^x04 45000 опыта")
	ColorChat(0, RED, "^x04[AMXX]^x01Его ^x03награда ^x04 45000 опыта")
	ColorChat(0, RED, "^x04[AMXX]^x01Его ^x03награда ^x04 45000 опыта")
	server_cmd("wc3_givexp %s 45000", szName, g_mostheadshots[iBestPlayerHeadshot])
	if(get_pcvar_num(cvar_logs)) {
		static mapname[32]
		get_mapname(mapname, sizeof mapname - 1)
		log_to_file("best_headshot.log", "Map %s | Best Player: %s | Headshot's: %d", mapname,  szName, g_mostheadshots[iBestPlayerHeadshot])
	}
	//return PLUGIN_HANDLED
}

public Event_DeathMsg( ) // Thanks Asd' (Fraan') From the help in this code :)
{
	new iAttack = read_data( 1 )
	new iVictim = read_data( 2 )
	new iHead = read_data( 3 )
	
	if( iVictim && iHead )
		g_mostheadshots[ iAttack ]++
}

ColorChat(id, Color:type, const msg[], {Float,Sql,Result,_}:...) {
	new message[256];

	switch(type) {
		case NORMAL:	message[0] = 0x01;
		case GREEN:	message[0] = 0x04;
		default:	message[0] = 0x03;
	}

	vformat(message[1], 251, msg, 4);

	// Make sure message is not longer than 192 character. Will crash the server.
	message[192] = '^0';

	new team, ColorChange, index, MSG_Type;
	
	if(id) {
		MSG_Type = MSG_ONE;
		index = id;
	} else {
		index = FindPlayer();
		MSG_Type = MSG_ALL;
	}
	
	team = get_user_team(index);
	ColorChange = ColorSelection(index, MSG_Type, type);

	ShowColorMessage(index, MSG_Type, message);
		
	if(ColorChange)
		Team_Info(index, MSG_Type, TeamName[team]);
}

ShowColorMessage(id, type, message[]) {
	static bool:saytext_used;
	static get_user_msgid_saytext;
	if(!saytext_used) {
		get_user_msgid_saytext = get_user_msgid("SayText");
		saytext_used = true;
	}
	message_begin(type, get_user_msgid_saytext, _, id);
	write_byte(id);
	write_string(message);
	message_end();	
}

Team_Info(id, type, team[]) {
	static bool:teaminfo_used;
	static get_user_msgid_teaminfo;
	if(!teaminfo_used) {
		get_user_msgid_teaminfo = get_user_msgid("TeamInfo");
		teaminfo_used = true;
	}
	message_begin(type, get_user_msgid_teaminfo, _, id);
	write_byte(id);
	write_string(team);
	message_end();

	return 1;
}

ColorSelection(index, type, Color:Type) {
	switch(Type) {
		case RED:	return Team_Info(index, type, TeamName[1]);
		case BLUE:	return Team_Info(index, type, TeamName[2]);
		case GREY:	return Team_Info(index, type, TeamName[0]);
	}

	return 0;
}

FindPlayer(){
	new i = -1;

	while(i <= get_maxplayers())
		if(is_user_connected(++i))
			return i;
	
	return -1;
}